/*
 * GlushkovFirst.h
 *
 *  Created on: 14. 4. 2016
 *	  Author: Tomas Pecka
 */

#ifndef RTE_GLUSHKOV_FIRST_H_
#define RTE_GLUSHKOV_FIRST_H_

#include <set>

#include <rte/formal/FormalRTE.h>
#include <rte/RTEFeatures.h>

#include <alphabet/RankedSymbol.h>

namespace rte {

class GlushkovFirst {
public:
	/**
	 * @param re rte to probe
	 * @return all rteSymbols which can be root of the tree.
	 */
	static std::set < std::ranked_symbol < > > first ( const rte::FormalRTE < > & re );

	class Formal {
	public:
		static std::set < std::ranked_symbol < > > visit ( const rte::FormalRTEAlternation < alphabet::Symbol, primitive::Unsigned > & node );
		static std::set < std::ranked_symbol < > > visit ( const rte::FormalRTESubstitution < alphabet::Symbol, primitive::Unsigned > & node );
		static std::set < std::ranked_symbol < > > visit ( const rte::FormalRTEIteration < alphabet::Symbol, primitive::Unsigned > & node );
		static std::set < std::ranked_symbol < > > visit ( const rte::FormalRTESymbolAlphabet < alphabet::Symbol, primitive::Unsigned > & node );
		static std::set < std::ranked_symbol < > > visit ( const rte::FormalRTESymbolSubst < alphabet::Symbol, primitive::Unsigned > & node );
		static std::set < std::ranked_symbol < > > visit ( const rte::FormalRTEEmpty < alphabet::Symbol, primitive::Unsigned > & node );
	};
};

} /* namespace rte */

#endif /* RTE_GLUSHKOV_FIRST_H_ */
