/*
 * GlushkovPos.cpp
 *
 *  Created on: 14. 4. 2016
 *	  Author: Tomas Pecka
 */

#include "GlushkovPos.h"
#include <rte/formal/FormalRTEElements.h>

namespace rte {

bool GlushkovPos::pos ( const std::ranked_symbol < > & symbol, const rte::FormalRTE < > & rte ) {
	return rte.getRTE ( ).getStructure ( ).accept < bool, GlushkovPos::Formal > ( symbol );
}

bool GlushkovPos::Formal::visit ( const rte::FormalRTEAlternation < alphabet::Symbol, primitive::Unsigned > & node, const std::ranked_symbol < > & symbolF ) {
	return node.getLeftElement ( ).accept < bool, GlushkovPos::Formal > ( symbolF ) || node.getRightElement ( ).accept < bool, GlushkovPos::Formal > ( symbolF );
}

bool GlushkovPos::Formal::visit ( const rte::FormalRTESubstitution < alphabet::Symbol, primitive::Unsigned > & node, const std::ranked_symbol < > & symbolF ) {
	return node.getLeftElement ( ).accept < bool, GlushkovPos::Formal > ( symbolF ) || node.getRightElement ( ).accept < bool, GlushkovPos::Formal > ( symbolF );
}

bool GlushkovPos::Formal::visit ( const rte::FormalRTEIteration < alphabet::Symbol, primitive::Unsigned > & node, const std::ranked_symbol < > & symbolF ) {
	return node.getElement ( ).accept < bool, GlushkovPos::Formal > ( symbolF );
}

bool GlushkovPos::Formal::visit ( const rte::FormalRTESymbolAlphabet < alphabet::Symbol, primitive::Unsigned > & node, const std::ranked_symbol < > & symbolF ) {
	if ( symbolF == node.getSymbol ( ) ) return true;

	for ( const std::smart_ptr < const rte::FormalRTESymbol < alphabet::Symbol, primitive::Unsigned > > & element : node.getElements ( ) )
		if ( element->accept < bool, GlushkovPos::Formal > ( symbolF ) )
			return true;

	return false;
}

bool GlushkovPos::Formal::visit ( const rte::FormalRTESymbolSubst < alphabet::Symbol, primitive::Unsigned > & node, const std::ranked_symbol < > & symbolF ) {
	return symbolF == node.getSymbol ( );
}

bool GlushkovPos::Formal::visit ( const rte::FormalRTEEmpty < alphabet::Symbol, primitive::Unsigned > & /* node */, const std::ranked_symbol < > & /* symbolF */ ) {
	return false;
}

} /* namespace rte */
