#include "EpsilonClosureTest.h"

#include <automaton/FSM/EpsilonNFA.h>

#include "automaton/properties/EpsilonClosure.h"
#include "automaton/properties/AllEpsilonClosure.h"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( EpsilonClosureTest, "automaton" );
CPPUNIT_TEST_SUITE_REGISTRATION( EpsilonClosureTest );

void EpsilonClosureTest::setUp() {
}

void EpsilonClosureTest::tearDown() {
}

void EpsilonClosureTest::testEpsilonClosure() {
	label::Label q0 = label::Label ("q0");
	label::Label q1 = label::Label ("q1");
	label::Label q2 = label::Label ("q2");
	label::Label q3 = label::Label ("q3");
	label::Label q4 = label::Label ("q4");
	label::Label q5 = label::Label ("q5");
	label::Label q6 = label::Label ("q6");
	label::Label q7 = label::Label ("q7");
	label::Label q8 = label::Label ("q8");
	label::Label q9 = label::Label ("q9");

	automaton::EpsilonNFA < > automaton(q0);
	automaton.setStates({q0, q1, q2, q3, q4, q5, q6, q7, q8, q9});

	automaton.addTransition(q0, q1);
	automaton.addTransition(q1, q2);
	automaton.addTransition(q2, q3);
	automaton.addTransition(q3, q4);
	automaton.addTransition(q4, q1);
	automaton.addTransition(q5, q6);
	automaton.addTransition(q6, q1);
	automaton.addTransition(q8, q8);

	std::map<label::Label, std::set<label::Label>> allClosures = automaton::properties::AllEpsilonClosure::allEpsilonClosure(automaton);

	for(const label::Label& state : automaton.getStates()) {
		CPPUNIT_ASSERT(automaton::properties::EpsilonClosure::epsilonClosure(automaton, state) == allClosures[state]);
	}
}
