#ifndef LR0_PARSER_TEST_H_
#define LR0_PARSER_TEST_H_

#include "grammar/ContextFree/CFG.h"
#include "alphabet/Symbol.h"

#include <cppunit/extensions/HelperMacros.h>

class LR0Parser : public CppUnit::TestFixture {
	CPPUNIT_TEST_SUITE ( LR0Parser );
	CPPUNIT_TEST ( testClosure );
	CPPUNIT_TEST ( testNextStateItems );
	CPPUNIT_TEST ( testAutomaton );
	CPPUNIT_TEST_SUITE_END ( );

	alphabet::Symbol E = alphabet::Symbol ( 'E' );
	alphabet::Symbol T = alphabet::Symbol ( 'T' );
	alphabet::Symbol F = alphabet::Symbol ( 'F' );

	alphabet::Symbol plus = alphabet::Symbol ( '+' );
	alphabet::Symbol times = alphabet::Symbol ( '*' );
	alphabet::Symbol leftParenthesis = alphabet::Symbol ( '(' );
	alphabet::Symbol rightParenthesis = alphabet::Symbol ( ')' );
	alphabet::Symbol identifier = alphabet::Symbol ( "id" );

	grammar::CFG < > getExpressionGrammar ( );

public:
	void setUp ( );
	void tearDown ( );

	void testClosure ( );
	void testNextStateItems ( );
	void testAutomaton ( );
};

#endif /* LR0_PARSER_TEST_H_ */
