#ifndef LR_PARSER_TEST_H_
#define LR_PARSER_TEST_H_

#include "grammar/ContextFree/CFG.h"
#include "alphabet/Symbol.h"

#include <cppunit/extensions/HelperMacros.h>

class LRParser : public CppUnit::TestFixture {
	CPPUNIT_TEST_SUITE ( LRParser );
	CPPUNIT_TEST ( testEndOfInputSymbol );
	CPPUNIT_TEST ( testParseCorrectInput );
	CPPUNIT_TEST ( testParseIncorrectInput );
	CPPUNIT_TEST_SUITE_END ( );

	alphabet::Symbol E = alphabet::Symbol ( 'E' );
	alphabet::Symbol T = alphabet::Symbol ( 'T' );
	alphabet::Symbol F = alphabet::Symbol ( 'F' );

	alphabet::Symbol plus = alphabet::Symbol ( '+' );
	alphabet::Symbol times = alphabet::Symbol ( '*' );
	alphabet::Symbol leftParenthesis = alphabet::Symbol ( '(' );
	alphabet::Symbol rightParenthesis = alphabet::Symbol ( ')' );
	alphabet::Symbol identifier = alphabet::Symbol ( "id" );

	grammar::CFG < > getExpressionGrammar ( );

public:
	void setUp ( );
	void tearDown ( );

	void testEndOfInputSymbol ( );
	void testParseCorrectInput ( );
	void testParseIncorrectInput ( );
};

#endif /* LR_PARSER_TEST_H_ */
