/*
 * Symbol.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Jan Travnicek
 */

#include "Symbol.h"
#include "LabeledSymbol.h"
#include <core/xmlApi.hpp>

namespace alphabet {

void Symbol::inc ( ) {
	this->operator ++ ( );
}

Symbol::Symbol ( int number ) : alib::WrapperBase < SymbolBase > ( alphabet::LabeledSymbol { label::Label ( number ) } ) {
}

Symbol::Symbol ( char character ) : alib::WrapperBase < SymbolBase > ( alphabet::LabeledSymbol { label::Label ( character ) } ) {
}

Symbol::Symbol ( std::string string ) : alib::WrapperBase < SymbolBase > ( alphabet::LabeledSymbol { label::Label ( std::move ( string ) ) } ) {
}

Symbol::Symbol ( const char * string ) : Symbol ( ( std::string ) string ) {
}

} /* namespace alphabet */

namespace alib {

auto SymbolDeleter = xmlApi < alphabet::Symbol >::InputContextDeleter ( );

}
