/*
 * AllEpsilonClosure.h
 *
 *  Created on: 12. 4. 2015
 *	  Author: Jan Travnicek
 */

#ifndef EFFICIENT_ALL_EPSILON_CLOSURE_H_
#define EFFICIENT_ALL_EPSILON_CLOSURE_H_

#include <core/multipleDispatch.hpp>
#include <set>
#include <map>

#include "automaton/Automaton.h"
#include "automaton/AutomatonFeatures.h"

#include <label/Label.h>

namespace automaton {

namespace properties {

namespace efficient {

class AllEpsilonClosure : public std::SingleDispatch<AllEpsilonClosure, std::map<label::Label, std::set<label::Label>>, const automaton::AutomatonBase &> {
public:
	static std::map<label::Label, std::set<label::Label>> allEpsilonClosure( const automaton::Automaton & automaton);

	/**
	 * Computes allEpsilon closure of a state in allEpsilon nonfree automaton
	 */
	static std::map<label::Label, std::set<label::Label>> allEpsilonClosure( const automaton::EpsilonNFA < > & fsm);
	static std::map<label::Label, std::set<label::Label>> allEpsilonClosure( const automaton::MultiInitialStateNFA < > & fsm);
	static std::map<label::Label, std::set<label::Label>> allEpsilonClosure( const automaton::NFA < > & fsm);
	static std::map<label::Label, std::set<label::Label>> allEpsilonClosure( const automaton::DFA < > & fsm);
	static std::map<label::Label, std::set<label::Label>> allEpsilonClosure( const automaton::ExtendedNFA < > & fsm);
	static std::map<label::Label, std::set<label::Label>> allEpsilonClosure( const automaton::CompactNFA < > & fsm);
};

} /* namespace efficient */

} /* namespace properties */

} /* namespace automaton */

#endif /* EFFICIENT_ALL_EPSILON_CLOSURE_H_ */
