#include <list>
#include "trimTest.h"

#include "automaton/simplify/Trim.h"

#include "automaton/FSM/DFA.h"

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( trimTest, "automaton" );
CPPUNIT_TEST_SUITE_REGISTRATION( trimTest );

void trimTest::setUp() {
}

void trimTest::tearDown() {
}

void trimTest::testTrimAutomaton() {
	automaton::DFA<> automaton(label::Label(1));

	automaton.addState(label::Label(1));
	automaton.addState(label::Label(2));
	automaton.addState(label::Label(3));
	automaton.addInputSymbol(alphabet::Symbol("a"));
	automaton.addInputSymbol(alphabet::Symbol("b"));

	automaton.addTransition(label::Label(1), alphabet::Symbol("a"), label::Label(2));
	automaton.addTransition(label::Label(2), alphabet::Symbol("b"), label::Label(1));
	automaton.addTransition(label::Label(3), alphabet::Symbol("b"), label::Label(1));

	automaton.addFinalState(label::Label(1));

	automaton::DFA<> trimed = automaton::simplify::Trim::trim(automaton);

	CPPUNIT_ASSERT(trimed.getStates().size() == 2);
}
